#include <wiringPi.h>
#include <stdio.h>	// for printf()

#define PIN_IRSENSOR 	(25)	// ԊOZT[s

#define MICROS_LEARNINGTIMEOUT (32000)		// 32000}CNb=0.032biShort^̏32767ɐݒj

void setup(void)
{
	pinMode( PIN_IRSENSOR, INPUT );
}

void loop(void)
{
	static int s_iState_prev = HIGH;			// ԊOZT[HighLowԁiԂ́AԊOȂŁAHIGHj
	static unsigned int s_uiMicros_prev = 0;	// OHighLowω̎

	static int 	s_iCountHighLow = 0;			// wKHighLowԂ̌

	int iState = digitalRead( PIN_IRSENSOR ); // ZT[lǂݎ
	if( iState != s_iState_prev )
	{	// ZT[lς
		// OZT[lωԂ̌oߎԂZo
		unsigned int uiMicros = micros();
		if( 0 == s_uiMicros_prev )
		{	// 1ڂ̕ώAuԂHIGHvˁuLOWvB
			s_iCountHighLow = 0;
		}
		else
		{	// LowԂHigh
			short shMicros_diff = (short)(uiMicros - s_uiMicros_prev);
			s_iCountHighLow++;
			printf( "%d, ", shMicros_diff );
		}
		s_uiMicros_prev = uiMicros;
		s_iState_prev = iState;
		return;	// ZT[lω̏ς݁Ã[v̏IB
	}

	if( s_uiMicros_prev )
	{	// wKis_uiMicros_prev[ȊOjŃZT[lω̂ȂԂ^CAEgbo߂wKIB
		if( MICROS_LEARNINGTIMEOUT < micros() - s_uiMicros_prev )
		{	// wK^CAEg
			// wK^CAEǵuԂHIGHvԂłA
			// wKʂƂẮALowԁAHighԁALowԁAAALow
			// ƁAHighLowԂ̌͊ԁB
			if( 0 == s_iCountHighLow % 2 )
			{	// HighLowԂ̌Ȃ̂ŁAwKs
				printf( "\nFailed : Learning\n" );
			}
			else
			{	// HighLowԂ̌Ȃ̂ŁAwK
				// ŌLowԂǉB
				printf( "%d, ", MICROS_LEARNINGTIMEOUT );
				printf( "\nSucceeded : Learning\n" );
			}
			s_uiMicros_prev = 0;
			return;	// wKÎŁÃ[v̏IB
		}
	}
}

int main(void)
{
	// Wiring PiZbgAbvBGPIOsԍgpZbgAbv֐gpB
	wiringPiSetupGpio();
	
	setup();
	
	while(1)
	{
		loop();
	}
	
	return 0;
}
